#include "widgetsimu.h"
#include "robot3d.h"

#define RadToDeg 180/M_PI

WidgetSimu::WidgetSimu(QWidget *parent) :
    QGLWidget(parent)
{   Zoom=0.5;
    xCam=-90; yCam=0;  zCam=20;  // rotation de la camera
    grabKeyboard();
}


void WidgetSimu::Start()
{   if (rob1.dt==0)  rob1.dt=0.02; else rob1.dt=0;
}


void WidgetSimu::initializeGL()
{
    glEnable(GL_LIGHT0);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_NORMALIZE);
    glClearColor(0.9,0.9,1,1);  //arrire plan
    glEnable(GL_LIGHTING);
    glEnable(GL_COLOR_MATERIAL);
}

void WidgetSimu::paintGL()
{
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        glLoadIdentity();
        glTranslated(0.0,-1.5, -10.0);   // On dcale vers le bas voir quelque chose de haut
        glRotated(xCam, 1.0, 0.0, 0.0);  // On tourne le repre.
        glRotated(yCam, 0.0, 1.0, 0.0);
        glRotated(zCam, 0.0, 0.0, 1.0);
        glScalef( Zoom, Zoom, Zoom);
        glPushMatrix();
          DrawSol();
          DrawEnvironnement();
        glPopMatrix();
        DrawRobot();
}

void WidgetSimu::resizeGL(int width, int height)
{
    int side = qMin(width, height);
    glViewport((width-side)/2, (height-side)/2, side, side);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glFrustum(-1.0, +1.0, -1.0, 1.0, 5.0, 60.0);
    glMatrixMode(GL_MODELVIEW);
}


void WidgetSimu::keyPressEvent(QKeyEvent *event)
{   switch (event->key())
    {
       case Qt::Key_Plus:  Zoom=Zoom*1.1;   break;
       case Qt::Key_Minus: Zoom=Zoom/1.1;  break;
    }
}

void WidgetSimu::DrawSol()
{       glBegin(GL_POLYGON);
           glColor3f(0,1.0,1.0);
           glVertex3f(-100,-100,0);   glVertex3f(100,-100,0);
           glVertex3f(100,100,0);     glVertex3f(-100,100,0);
        glEnd();
}

void WidgetSimu::DrawEnvironnement()
{   glColor3f(0.9,0.9,0.9);
    GLUquadricObj *q1=gluNewQuadric();  //mt
    gluCylinder(q1,0.2,0.2,3, 5,10);
    gluDeleteQuadric(q1);
    for (int k=1;k<10;k++)
    {  glTranslatef(10,0, 0);
       glColor3f(1, 0.0, 0.0); //rouge
       GLUquadricObj* q=gluNewQuadric();
       gluSphere(q,1.0,10,10);
    }
}

void WidgetSimu::DrawRobot()
{       glTranslated(rob1.x,rob1.y,0.0);
        glRotatef(rob1.theta*RadToDeg,0.0,0.0,1.0);
        glBegin(GL_POLYGON);
                   glColor3f(0.5,0.5,1);
                   glVertex3f(-1,-1,1); glVertex3f(-1,1,1); glVertex3f(3,0,1);
        glEnd();
}

void WidgetSimu::Clock()   //Sequenceur
{   rob1.Clock();
    DrawRobot();
    updateGL();
}
