#ifndef WIDGETSIMU_H
#define WIDGETSIMU_H

#include <QtGui/QGraphicsView>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <string.h>
#include <QKeyEvent>
#include <QGLWidget>
#include "robot3d.h"

class WidgetSimu : public QGLWidget
{
    Q_OBJECT
public:
    explicit WidgetSimu(QWidget *parent = 0);

signals:

public slots:
   void Start();
   void Clock();

protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void keyPressEvent(QKeyEvent *event);

private:
    void DrawSol();
    void DrawEnvironnement();
    void DrawRobot();
    int xCam,yCam,zCam;
    float Zoom;
    robot3d rob1;
};

#endif // WIDGETSIMU_H
